Last Comment Bug 717182 - Permanent orange on Windows | TEST-UNEXPECTED-FAIL | test_largeOfflineStore.js (NS_ERROR_FILE_NO_DEVICE_SPACE)
: Permanent orange on Windows | TEST-UNEXPECTED-FAIL | test_largeOfflineStore.j...
Status: VERIFIED FIXED
: intermittent-failure
Product: MailNews Core
Classification: Components
Component: Backend (show other bugs)
: Trunk
: All Windows Server 2003
: -- normal (vote)
: Thunderbird 12.0
Assigned To: Mark Banner (:standard8)
:
Mentors:
Depends on:
Blocks: 718190
  Show dependency treegraph
 
Reported: 2012-01-11 00:36 PST by Mark Banner (:standard8)
Modified: 2012-11-25 19:31 PST (History)
2 users (show)
bugzillamozillaorg_serge_20140323: in‑testsuite+
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---


Attachments
Proposed fix (1.51 KB, patch)
2012-01-13 02:20 PST, Mark Banner (:standard8)
mozilla: review+
Details | Diff | Splinter Review

Description Mark Banner (:standard8) 2012-01-11 00:36:54 PST
I think this has been present since the pluggable store landing. Only happening on Windows:

TEST-UNEXPECTED-FAIL | e:\buildbot\comm-central-win32-opt-unittest-xpcshell\build\xpcshell\tests\mailnews\imap\test\unit\test_largeOfflineStore.js | test failed (with xpcshell return code: 0), see following log:
>>>>>>>

TEST-INFO | (xpcshell/head.js) | test 1 pending
Directory request for: SysD that we (mailDirService.js) are not handling, leaving it to another handler.
Directory request for: MailD that we (mailDirService.js) are not handling, leaving it to another handler.
Directory request for: MFCaF that we (mailDirService.js) are not handling, leaving it to another handler.
Directory request for: DefRt that we (mailDirService.js) are not handling, leaving it to another handler.
Directory request for: IMapMD that we (mailDirService.js) are not handling, leaving it to another handler.

TEST-INFO | (xpcshell/head.js) | test 2 pending

NEXT ERROR TEST-UNEXPECTED-FAIL | xpcshell/head.js | [Exception... "Component returned failure code: 0x80520010 (NS_ERROR_FILE_NO_DEVICE_SPACE) [nsIFileOutputStream.write]"  nsresult: "0x80520010 (NS_ERROR_FILE_NO_DEVICE_SPACE)"  location: "JS frame :: e:/buildbot/comm-central-win32-opt-unittest-xpcshell/build/xpcshell/tests/mailnews/imap/test/unit/test_largeOfflineStore.js :: run_test :: line 104"  data: no]
<<<<<<<

If I look further up the log I see:

49.19 GB of space available

As these are only unit test builds, I'd be surprised if we were filling up 45GB of space with the unit test.
Comment 1 David :Bienvenu 2012-01-11 07:14:38 PST
I've never seen this on either of my windows machines. Maybe I need an older version of windows.
Comment 2 Mark Banner (:standard8) 2012-01-12 13:51:18 PST
John: This appears to be an issue with the builders themselves.

The tests are trying to write 2 and 4 GB files to the temp directories on the c drive (in c:\documents and settings\cltbld\local settings\temp iirc), however it appears those drives have now fallen to below 4GB in size.

Can you take a look and see if there's stuff we can clean up?
Comment 3 Mark Banner (:standard8) 2012-01-13 01:02:01 PST
Ok, re-evaluating this, it doesn't happen on branches, which implies it isn't the buildbot slaves that are the issue. Also, I've gone back to when it started and it was definitely the pluggable store landing, there were no m-c changes at the time.
Comment 4 Mark Banner (:standard8) 2012-01-13 02:20:41 PST
Created attachment 588348 [details] [diff] [review]
Proposed fix

This seems to fix the test - on Windows. The issue appears to be that the default arguments to outputstream.init were for write-only, create if necessary and truncate.

The truncate seems to have been messing with the file being marked as sparse. I don't know if all the tinderboxes loosing disk space coincided with the pluggable store landing (I think unlikely), but I don't quite know how to explain this otherwise.

I've currently got a full set of platforms running on try with this fix (although it passed for me on tinderbox windows and debug build mac):

http://build.mozillamessaging.com/tinderboxpushlog/?tree=ThunderbirdTry&rev=e16eee6f30bc
Comment 5 David :Bienvenu 2012-01-13 06:59:32 PST
Comment on attachment 588348 [details] [diff] [review]
Proposed fix

If this fixes it, great.

But test_over2GBMailboxes doesn't use sparse files - only test_over4GBMailboxes.js and test_largeOfflineStores.js use mark_file_region_sparse. Perhaps we should make test_over2GBMailboxes use sparse files as well.
Comment 6 Serge Gautherie (:sgautherie) 2012-01-13 17:57:15 PST
SeaMonkey is affected too.
Comment 7 Mark Banner (:standard8) 2012-01-14 05:20:11 PST
Checked in: http://hg.mozilla.org/comm-central/rev/a66d30b82ac2
Comment 8 Serge Gautherie (:sgautherie) 2012-01-14 08:16:18 PST
V.Fixed, per bug 718190 comment 0.


(In reply to Mark Banner (:standard8) from comment #4)
> I've currently got a full set of platforms running on try with this fix

Fixed 1 of the 2 failures only :-| (+/- expected)


(In reply to David :Bienvenu from comment #5)
> Perhaps we should make test_over2GBMailboxes use sparse files as well.

I filed bug 718190.

Note You need to log in before you can comment on or make changes to this bug.